﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using MathWorks.MATLAB.NET.Arrays;
using MathWorks.MATLAB.NET.Utility;
using EigensystemNameSpace ;

namespace Example
{
  class Program
  {
    static void Main(string[] args)
    {
      Console.WriteLine(" ") ;
      Program objProgram = new Program() ; 

      Console.WriteLine("Eigenvalues and eigenvectors" ) ;
      objProgram.EigValueVector() ;
    }

    /* **************************** */
    public void EigValueVector()  
    {
      double[,] A = {{ 0, -6, -1} , {6, 2, -16} ,  {-5, 20, -10} } ;
      int row = 3 ;
      int col = 3 ;
      int i, j ;

      // declare mx_Array variables //
      MWNumericArray mw_A = new MWNumericArray(A) ;
      MWArray [] mw_ArrayOut = null ;

      MWNumericArray mw_eigenvectors = null ;
      MWNumericArray mw_eigenvalues  = null ;

      /* call an implemental function */
      Eigensystem obj = new Eigensystem() ;
      mw_ArrayOut = obj.myeig(2, mw_A) ;
      Console.WriteLine("Eigen of the matrix A : \n {0}", mw_ArrayOut) ;

      mw_eigenvectors = (MWNumericArray) mw_ArrayOut[0] ;
      mw_eigenvalues  = (MWNumericArray) mw_ArrayOut[1] ;

      /* convert back to Cs double  */
      double[,] db_eigenvectorsReal = new double [row, col] ;
      double[,] db_eigenvectorsImag = new double [row, col] ;

      double[,] db_eigenvaluesReal = new double [row, col] ;
      double[,] db_eigenvaluesImag = new double [row, col] ;

      db_eigenvectorsReal = (double[,]) mw_eigenvectors.ToArray(MWArrayComponent.Real) ;
      db_eigenvaluesReal  = (double[,]) mw_eigenvalues.ToArray(MWArrayComponent.Real)  ;

      try
      {
        db_eigenvectorsImag = (double[,])mw_eigenvectors.ToArray(MWArrayComponent.Imaginary);
        db_eigenvaluesImag  = (double[,])mw_eigenvalues.ToArray (MWArrayComponent.Imaginary);
      }

      catch
      {
        // nothing, db_eigenvectorsImag and db_eigenvaluesImag will be assigned value of zero
      }

      /* print out */
      Console.WriteLine("Eigenvalues of the matrix A : " ) ;

      for (i=0; i<row; i++)  
      {
        Console.Write( db_eigenvaluesReal.GetValue(i,i) +  " + "  ) ;
        Console.Write( db_eigenvaluesImag.GetValue(i,i) +  "i"  + "\n"  ) ;
      }
      
      Console.Write("\n") ;
      Console.WriteLine("Eigenvectors of the matrix A : " ) ;

      for (j=0; j<col; j++ ) 
      {
        Console.WriteLine("Eigenvector {0} is : ", (j+1).ToString()  ) ;

        for (i=0; i<row; i++)  
        {
          Console.Write( db_eigenvectorsReal.GetValue(i,j) + " + "  ) ;
          Console.Write( db_eigenvectorsImag.GetValue(i,j) + "i" + "\n") ;
        }

        Console.Write("\n") ;
      }

      Console.Write("\n") ;
      /* free memory */
      mw_A.Dispose() ;
      MWNumericArray.DisposeArray(mw_ArrayOut) ;

      mw_eigenvectors.Dispose() ;
      mw_eigenvalues.Dispose() ;  
    }

/* **************************** */
/* **************************** */
/* **************************** */
  }
}
