﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO ;

using MathWorks.MATLAB.NET.Arrays;
using MathWorks.MATLAB.NET.Utility;
using GeneratingGraphicsNameSpace;

namespace Example
{
  class Program
  {
    static void Main(string[] args)
    {
      Console.WriteLine(" Using the plot function. Please wait. ") ; 
      Program objProgram = new Program() ;
      
      // Prolem 1: Plot a simple 2D figure
      //objProgram.SimplePlot() ;
      

      // Prolem : Plot a 2D figure by passing arrays            
      /*
      double[]X = {0, 50, 100, 150, 200, 250, 300, 350, 400, 450, 500, 550, 600} ;

      double[]Y = {0.4000, 0.2426, 0.1472, 0.0893, 0.0541, 0.0328, 0.0199, 
                  0.0121, 0.0073, 0.0044, 0.0027, 0.0016,  0.0010 } ;
   	
      objProgram.AnotherSimplePlot(X, Y) ;
      */

      /*
      // Prolem 2: Plot a 2D figure with data from a file
      objProgram.PlotDataFromFile() ;             
      */      
     
      /*            
      // Problem 3: Plot multiple figures with data from math functions
       objProgram.PlotFromFunctions() ;                                 
      */   

      /*
      // Problem 4: Plot multiple figures with data from arrays
      objProgram.MultiPlotFromArrays() ;
      */

      // Problem 5: Plot multiple figures with data from a file
      objProgram.MultiPlotFromFile() ;
    }

    /* **************************** */
    public void SimplePlot() 
    {
      double[] db_vectorX =  { 11.1,	22.2 , 33.3  } ;
      double[] db_vectorY =  { 110.1,	220.2, 330.3 } ;

      String strColor = "k" ; // k: black, b: blue, r: red

      // Declare mwArray variables 
      MWNumericArray mw_X = new MWNumericArray(db_vectorX) ;
      MWNumericArray mw_Y = new MWNumericArray(db_vectorY) ;

      // Set color, see color symbols in MATLAB Graphics
      MWCharArray mw_strColor  = new MWCharArray(strColor)      ;

    // Call the implemental function 
      GeneratingGraphics objMatlab = new GeneratingGraphics() ;
      objMatlab.simplePlot(mw_X, mw_Y, mw_strColor);
      objMatlab.WaitForFiguresToDie() ; // program will continue after close this figure

      /*
      Typically you use WaitForFiguresToDie when:
      . There are one or more figures open that were created 
        by a .NET component created by the builder.
      . The method that displays the graphics requires user input before continuing.
      . The method that calls the figures was called from main() in a console program.

      When WaitForFiguresToDie is called, execution of the calling program is blocked 
      if any figures created by the calling object remain open.
      */

      mw_strColor.Dispose() ;
      mw_X.Dispose() ;
      mw_Y.Dispose() ;            
    }    

    /* **************************** */
    public void AnotherSimplePlot(double[] arrayX, double[] arrayY) 
    {
      String strColor = "b" ; // k: black, b: blue, r: red

      // Declare mwArray variables 
      MWNumericArray mw_X = new MWNumericArray(arrayX) ;
      MWNumericArray mw_Y = new MWNumericArray(arrayY) ;

      // Set color, see color symbols in MATLAB Graphics
      MWCharArray mw_strColor  = new MWCharArray(strColor)      ;

    // Call the implemental function
      GeneratingGraphics objMatlab = new GeneratingGraphics() ;
      objMatlab.simplePlot(mw_X, mw_Y, mw_strColor);
      objMatlab.WaitForFiguresToDie() ; // program will continue after close this figure

      mw_strColor.Dispose() ;
      mw_X.Dispose() ;
      mw_Y.Dispose() ;            
    }
       
    /* **************************** */
    public void PlotDataFromFile()
    {
      // Reading data from a file
      const string fileName = "PlottingFile.txt";
      
      MWArray [] mw_ArrayOut = null ;
      MWNumericArray mw_X = null ;
      MWNumericArray mw_Y = null ;

      GeneratingGraphics objMatlab = new GeneratingGraphics() ;
      String delimiter = @" " ; // blank
      int numCol = 2 ;

      // Value of the first 2 is two of ouput of varargout in mytextread.m
      mw_ArrayOut = objMatlab.mytextread(2, fileName, numCol, delimiter) ;

      mw_X = (MWNumericArray) mw_ArrayOut[0] ;
      mw_Y = (MWNumericArray) mw_ArrayOut[1] ;

      // End of Reading data from a file

      // Set color, see color symbols in MATLAB Graphics
      // Plot graphic
      String strColor = "r" ; // k: black, b: blue, r: red
      MWCharArray mw_strColor  = new MWCharArray(strColor) ;
      objMatlab.simplePlot(mw_X, mw_Y, mw_strColor);

      objMatlab.WaitForFiguresToDie() ; // program will continue after close this figure

      mw_strColor.Dispose() ;
      MWNumericArray.DisposeArray(mw_ArrayOut) ;
      mw_X.Dispose() ;
      mw_Y.Dispose() ;      
    }

    /* **************************** */
    public void PlotFromFunctions() {

      String strfunc1 = "cos(t)"          ;
      String strfunc2 = "cos(t + pi/3)"   ;
      String strfunc3 = "cos(t + 2*pi/3)" ;

      MWCharArray  strPlot1 = new MWCharArray(strfunc1)	;
      MWCharArray  strPlot2 = new MWCharArray(strfunc2)	;
      MWCharArray  strPlot3 = new MWCharArray(strfunc3)	;

      MWCharArray markerPlot1 = new MWCharArray("*") ; 
      MWCharArray markerPlot2 = new MWCharArray("^") ; 
      MWCharArray markerPlot3 = new MWCharArray("o") ; 

      MWCharArray colorPlot1 = new MWCharArray("r") ;	// red
      MWCharArray colorPlot2 = new MWCharArray("b") ; // blue
      MWCharArray colorPlot3 = new MWCharArray("k") ; // black

      MWCharArray  strTitle  = new MWCharArray("Figure Legends "  ) ;
      MWCharArray  strxlabel = new MWCharArray("My x label "	    ) ;
      MWCharArray  strylabel = new MWCharArray("My y label "	    ) ;

      // Call the implemental function 
      GeneratingGraphics objMatlab = new GeneratingGraphics();
      objMatlab.multiPlotForFuncs(strPlot1, colorPlot1, markerPlot1,
                                  strPlot2, colorPlot2, markerPlot2,
                                  strPlot3, colorPlot3, markerPlot3,
                                  strTitle, strxlabel , strylabel) ;

      objMatlab.WaitForFiguresToDie() ; // program will continue after close this figure

      strPlot1.Dispose()      ; 
      strPlot2.Dispose()      ;
      strPlot3.Dispose()      ;

      markerPlot1.Dispose()   ;
      markerPlot2.Dispose()   ;
      markerPlot3.Dispose()   ;

      colorPlot1.Dispose()    ; 
      colorPlot2.Dispose()    ; 
      colorPlot3.Dispose()    ; 

      strTitle.Dispose()      ;  
      strxlabel.Dispose()     ; 
      strylabel.Dispose()     ; 
    }
    
    /* **************************** */
    public void MultiPlotFromArrays() 
    {
      double[] db_vectort =   {   0.1,   0.2,	 0.3  } ;
  	
      double[] db_vectorY1 =  {  11.1,  22.2, 33.3  } ;
      double[] db_vectorY2 =  {  40.1,  50.2, 60.3  } ;
      double[] db_vectorY3 =  {  70.1,  80.2, 90.3  } ;
      double[] db_vectorY4 =  { 100.1, 110.2,	120.3 } ;

      // Declare mwArray variables 
      MWNumericArray mw_t  = new MWNumericArray(db_vectort ) ;

      MWNumericArray mw_y1 = new MWNumericArray(db_vectorY1) ;
      MWNumericArray mw_y2 = new MWNumericArray(db_vectorY2) ;
      MWNumericArray mw_y3 = new MWNumericArray(db_vectorY3) ;
      MWNumericArray mw_y4 = new MWNumericArray(db_vectorY4) ;

      // Set properties for MATLAB Graphics
      MWCharArray mw_Title  = new MWCharArray("The Title" ) ;  
      MWCharArray mw_xlabel = new MWCharArray("time"	    ) ;  
      MWCharArray mw_ylabel = new MWCharArray("voltage"	) ;  

      // Call the implemental function 
      GeneratingGraphics objMatlab = new GeneratingGraphics() ; 
      objMatlab.multiPlotForArrays(mw_t, mw_y1, mw_y2, mw_y3, mw_y4, 
	                      mw_Title, mw_xlabel, mw_ylabel ) ;

      objMatlab.WaitForFiguresToDie() ; // program will continue after close this figure

      mw_t.Dispose() ; 

      mw_y1.Dispose() ; 
      mw_y2.Dispose() ; 
      mw_y3.Dispose() ; 
      mw_y4.Dispose() ; 

      mw_Title.Dispose()  ;  
      mw_xlabel.Dispose() ; 
      mw_ylabel.Dispose() ; 
    }

    /* **************************** */
    public void MultiPlotFromFile() 
    {
      // Read data from a file
      const string fileName = "MultiArrays.csv";

      MWArray [] mw_ArrayOut = null ;
      MWNumericArray mw_Col0 = null ;
      MWNumericArray mw_Col1 = null ;
      MWNumericArray mw_Col2 = null ;
      MWNumericArray mw_Col3 = null ;
      MWNumericArray mw_Col4 = null ;

      GeneratingGraphics objMatlab = new GeneratingGraphics() ;
      String delimiter = @"," ; // comma
      int numCol = 5 ;    

      // Value of the first 5 is five of ouput of varargout in mytextread.m
      mw_ArrayOut = objMatlab.mytextread(5, fileName, numCol, delimiter) ;

      mw_Col0 = (MWNumericArray) mw_ArrayOut[0] ;
      mw_Col1 = (MWNumericArray) mw_ArrayOut[1] ;
      mw_Col2 = (MWNumericArray) mw_ArrayOut[2] ;
      mw_Col3 = (MWNumericArray) mw_ArrayOut[3] ;
      mw_Col4 = (MWNumericArray) mw_ArrayOut[4] ;

      // End of Reading data from a file

      //Plot figures
      // Set properties for MATLAB Graphics
      MWCharArray mw_Title  = new MWCharArray("The Title");
      MWCharArray mw_xlabel = new MWCharArray("time");
      MWCharArray mw_ylabel = new MWCharArray("voltage");

      // Call the implemental function
      objMatlab.multiPlotForArrays(mw_Col0, mw_Col1, mw_Col2, mw_Col3, mw_Col4,
                                mw_Title, mw_xlabel, mw_ylabel);

      objMatlab.WaitForFiguresToDie() ; // program will continue after close this figure

      MWNumericArray.DisposeArray(mw_ArrayOut) ;
      mw_Col0.Dispose();
      mw_Col1.Dispose();
      mw_Col2.Dispose();
      mw_Col3.Dispose();
      mw_Col4.Dispose();

      mw_Title.Dispose();
      mw_xlabel.Dispose();
      mw_ylabel.Dispose(); 
    }
/* **************************** */
/* **************************** */
/* **************************** */
  }
}
