﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using MathWorks.MATLAB.NET.Utility;
using MathWorks.MATLAB.NET.Arrays ;
using MatrixMultiplicationNameSpace ;

namespace Example
{
  public partial class Form1 : Form
  {
    public TextBox[,] arrTextBoxMatrixA ;
    public double[,] db_MatrixA  ;

    public TextBox[,] arrTextBoxMatrixB ;
    public double[,] db_MatrixB  ;

    public TextBox[,] arrTextBoxMatrixC ;
    public double[,] db_MatrixC  ;

    public int m_numRowMatricATextBox ;
    public int m_numColMatricATextBox ;

    public int m_tbLength ;
    public int m_tbHeight ;

    public Point m_startPoint = new Point() ;
    public Point m_startPointMatrixB = new Point() ;
    public Point m_startPointMatrixC = new Point() ;

    int m_numRowMatrixBTextBox ;
    int m_numColMatrixBTextBox ;

    int m_FormLength ;
    int m_FormHeight ;

    int m_numRowMatriCTextBox ;
    int m_numColMatriCTextBox ;

    /* ************************************ */
    public Form1()
    {
      InitializeComponent();

      m_startPoint.X = 16 ;
      m_startPoint.Y = 202 ;

      m_numRowMatricATextBox = 5 ;
      m_numColMatricATextBox = 7 ;

      m_numRowMatrixBTextBox = m_numColMatricATextBox ;
      m_numColMatrixBTextBox = 4 ;

      m_numRowMatriCTextBox = m_numRowMatricATextBox ;
      m_numColMatriCTextBox = m_numColMatrixBTextBox ;

      m_tbLength = 38 ;
      m_tbHeight = 20 ;

      int adistance = 50 ;
      // = length of A + a distance
      m_startPointMatrixB.X = m_startPoint.X + (m_numColMatricATextBox)*(m_tbLength+2) 
                                                                     - 2 + adistance ;
      m_startPointMatrixB.Y = m_startPoint.Y ;

      int lbMatrixBlength = (m_numColMatrixBTextBox)*(m_tbLength+2) - 2; 
      m_FormLength = m_startPointMatrixB.X + lbMatrixBlength + adistance ;
      m_FormHeight = 500 ;

      arrTextBoxMatrixA   = new TextBox[m_numRowMatricATextBox, m_numColMatricATextBox] ;
      db_MatrixA      = new double [m_numRowMatricATextBox, m_numColMatricATextBox] ;

      arrTextBoxMatrixB   = new TextBox[m_numRowMatrixBTextBox, m_numColMatrixBTextBox] ;
      db_MatrixB      = new double [m_numRowMatrixBTextBox, m_numColMatrixBTextBox] ;

      arrTextBoxMatrixC   = new TextBox[m_numRowMatriCTextBox, m_numColMatriCTextBox] ;
      db_MatrixC      = new double [m_numRowMatriCTextBox, m_numColMatriCTextBox] ;

      SetProperty() ;
    }

    /* ************************************ */
    public void SetTextBoxMatrixA() 
    {
      for(int i=0; i<m_numRowMatricATextBox; i++) 
      {
        for(int j=0; j<m_numColMatricATextBox; j++)  
        {         
          arrTextBoxMatrixA[i,j] = new System.Windows.Forms.TextBox();
          arrTextBoxMatrixA[i,j].Location = new System.Drawing.Point(
                 m_startPoint.X + (m_tbLength+2)*j, m_startPoint.Y + (m_tbHeight+2)*i );
          arrTextBoxMatrixA[i,j].Name = "textBox1";
          arrTextBoxMatrixA[i,j].Size = new System.Drawing.Size(m_tbLength, m_tbHeight);
          arrTextBoxMatrixA[i,j].TabIndex = i;
          arrTextBoxMatrixA[i,j].Text = "0.0";
          this.Controls.Add(arrTextBoxMatrixA[i,j]) ;
        }
      }
    }

    /* ************************************ */
    public void SetLabelMatrixA() 
    {    
      Label lbMatrixA = new System.Windows.Forms.Label();

      int lbMatrixAlength = (m_numColMatricATextBox)*(m_tbLength+2) - 2;
      lbMatrixA.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, 
            System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 
                           ((System.Byte)(0)));
      lbMatrixA.Location = new System.Drawing.Point(m_startPoint.X, m_startPoint.Y - 40);
      lbMatrixA.Size = new System.Drawing.Size(lbMatrixAlength, 28);
      lbMatrixA.Name = "lbMatrixA";
      lbMatrixA.Text = "Matrix A";
      lbMatrixA.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;

      this.Controls.Add(lbMatrixA) ;
    }

    /* ************************************ */
    public void SetLabelMatrixB() 
    {
      Label lbMatrixB = new System.Windows.Forms.Label();
      lbMatrixB.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, 
        System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 
                                                        ((System.Byte)(0)));

      // row B = col A
      int lbMatrixBlength = (m_numColMatrixBTextBox)*(m_tbLength+2) - 2; ;
      lbMatrixB.Location = new System.Drawing.Point(m_startPointMatrixB.X, 
                                                    m_startPoint.Y - 40);
      lbMatrixB.Size = new System.Drawing.Size(lbMatrixBlength, 28);
      lbMatrixB.Name = "lbMatrixB";
      lbMatrixB.Text = "Matrix B";

      lbMatrixB.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
      this.Controls.Add(lbMatrixB) ;
    }

    /* ************************************ */
    public void SetLabelMatrixC() 
    {
      Label lbMatrixC = new System.Windows.Forms.Label();
      lbMatrixC.Font  = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, 
        System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

      // row B = col A
      int lbMatrixClength = (m_numColMatriCTextBox)*(m_tbLength+2) - 2; ;
      lbMatrixC.Location = new System.Drawing.Point(
                      m_startPointMatrixC.X, m_startPointMatrixC.Y - 40);
      lbMatrixC.Size = new System.Drawing.Size(lbMatrixClength, 28);
      lbMatrixC.Name = "lbMatrixC";
      lbMatrixC.Text = "Matrix C";

      lbMatrixC.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
      this.Controls.Add(lbMatrixC) ;
    }

    /* ************************************ */
    public void SetTextBoxMatrixB() 
    {
      for(int i=0; i<m_numRowMatrixBTextBox; i++) 
      {
        for(int j=0; j<m_numColMatrixBTextBox; j++)  
        {       
          arrTextBoxMatrixB[i,j] = new System.Windows.Forms.TextBox();
          arrTextBoxMatrixB[i,j].Location = new System.Drawing.Point(
           m_startPointMatrixB.X + (m_tbLength+2)*j, m_startPointMatrixB.Y + (m_tbHeight+2)*i );
          arrTextBoxMatrixB[i,j].Name = "textBox2";
          arrTextBoxMatrixB[i,j].Size = new System.Drawing.Size(m_tbLength, m_tbHeight);
          arrTextBoxMatrixB[i,j].TabIndex = i;
          arrTextBoxMatrixB[i,j].Text = "0.0";
          this.Controls.Add(arrTextBoxMatrixB[i,j]) ;
        }
      }
    }

    /* ************************************ */
    public void SetTextBoxMatrixC() 
    {
      for(int i=0; i<m_numRowMatriCTextBox; i++) 
      {
        for(int j=0; j<m_numColMatriCTextBox; j++)  
        {       
          arrTextBoxMatrixC[i,j] = new System.Windows.Forms.TextBox();
          arrTextBoxMatrixC[i,j].Location = new System.Drawing.Point(m_startPointMatrixC.X
                           + (m_tbLength+2)*j, m_startPointMatrixC.Y + (m_tbHeight+2)*i );
          arrTextBoxMatrixC[i,j].Name = "textBox2";
          arrTextBoxMatrixC[i,j].Size = new System.Drawing.Size(m_tbLength, m_tbHeight);
          arrTextBoxMatrixC[i,j].TabIndex = i;
          arrTextBoxMatrixC[i,j].Text = "0.0";
          arrTextBoxMatrixC[i,j].ReadOnly = true;
          this.Controls.Add(arrTextBoxMatrixC[i,j]) ;
        }
      }
    }

    /* ************************************ */
    private void btSetNumber_Click(object sender, System.EventArgs e)
    {
      int rowA, colA ;
      int rowB, colB ;

      try
      {
        rowA = Convert.ToInt32(tbMatrixA_row.Text);
        colA = Convert.ToInt32(tbMatrixA_col.Text);

        rowB = Convert.ToInt32(tbMatrixB_row.Text);
        colB = Convert.ToInt32(tbMatrixB_col.Text);
      }
      catch
      {
        MessageBox.Show("Please enter the number") ;
        return ;
      }

      m_numRowMatricATextBox = rowA ;
      m_numColMatricATextBox = colA ;

      m_numRowMatrixBTextBox = m_numColMatricATextBox ;
      m_numColMatrixBTextBox = colB ;

      m_numRowMatriCTextBox = m_numRowMatricATextBox ;
      m_numColMatriCTextBox = m_numColMatrixBTextBox ;

      try
      {
        SetProperty();
      }
      catch { 
        MessageBox.Show(@"This is an example for matrix multiplication C = A*B, with
        max of A = 7x5 and B = 5x4");
      } ;

    }

    /* ************************************ */
    public void SetProperty() 
    {
      this.Controls.Clear() ;
      m_tbLength = 38 ;
      m_tbHeight = 20 ;

      int adistance = 50 ;
      // = length of A + a distance
      m_startPointMatrixB.X = m_startPoint.X + (m_numColMatricATextBox)*(m_tbLength+2) 
                                                                         - 2 + adistance ;
      m_startPointMatrixB.Y = m_startPoint.Y ;

      int lbMatrixBlength = (m_numColMatrixBTextBox)*(m_tbLength+2) - 2; 

      m_startPointMatrixC.X = m_startPoint.X ;
      int aheight_A = m_startPoint.Y + (m_numRowMatricATextBox)*(m_tbHeight+2)+ 3*adistance ;
      int aheight_B = m_startPoint.Y + (m_numRowMatrixBTextBox)*(m_tbHeight+2)+ 3*adistance ;
      
      int aheight = Math.Max(aheight_A, aheight_B) ;
      m_startPointMatrixC.Y = aheight ;

      // reset form size
      InitializeComponent();
      tbMatrixA_row.Text = m_numRowMatricATextBox.ToString() ;
      tbMatrixA_col.Text = m_numColMatricATextBox.ToString() ;

      tbMatrixB_row.Text = m_numRowMatrixBTextBox.ToString() ;
      tbMatrixB_col.Text = m_numColMatrixBTextBox.ToString() ;

      m_numRowMatriCTextBox = m_numRowMatricATextBox ;
      m_numColMatriCTextBox = m_numColMatrixBTextBox ;
      
      SetLabelMatrixA() ;
      SetLabelMatrixB() ;
      SetLabelMatrixC() ;

      // set calculation button
      //this.btCalculation.Location = new System.Drawing.Point(m_startPoint.X, aheight - 100);

      SetTextBoxMatrixA() ;
      SetTextBoxMatrixB() ;
      SetTextBoxMatrixC() ;

      m_FormLength = m_startPointMatrixB.X + lbMatrixBlength + adistance ;
      m_FormHeight = m_startPointMatrixC.Y + m_numRowMatriCTextBox*(m_tbHeight+2) + adistance;

      m_FormLength = Math.Max(544, m_FormLength) ;
      this.ClientSize = new System.Drawing.Size(m_FormLength, m_FormHeight);

      this.Refresh() ;
    }

    /* ************************************ */
    private void btCalculation_Click(object sender, System.EventArgs e)
    {
      ////////// get matrix A /////////////
      try
      {
        GetMatrixA() ;
      }
      catch 
      {
        MessageBox.Show("Data in Matrix A is not valid") ;
        return ;
      }
             
      ////////// get matrix B /////////////
      try
      {
        GetMatrixB() ;
      }
      catch 
      {
        MessageBox.Show("Data in Matrix B is not valid") ;
        return ;
      }

          
      this.labelCalcInfo.Text = @"Calculation is in process. Please wait.";
      this.Invalidate() ;
      this.Refresh() ;
        
      /////////////// calculate matrix C ////////////
      GetMatrixC() ;

      labelCalcInfo.Text = @"Calculation has done";
    }

    /* ************************************ */
    public void GetMatrixA() 
    {
      int rowA, colA ;

      rowA = Convert.ToInt32(tbMatrixA_row.Text);
      colA = Convert.ToInt32(tbMatrixA_col.Text);
      int i, j ;

      for( i=0; i<m_numRowMatricATextBox; i++) 
      {
        for( j=0; j<m_numColMatricATextBox; j++)  
        {    
          db_MatrixA[i,j] = Convert.ToDouble(arrTextBoxMatrixA[i,j].Text) ;
        }
      }

    }

    /* ************************************ */
    public void GetMatrixB() 
    {
      int rowB, colB ;
      rowB = Convert.ToInt32(tbMatrixB_row.Text);
      colB = Convert.ToInt32(tbMatrixB_col.Text);

      int i, j ;

      for( i=0; i<m_numRowMatrixBTextBox; i++) 
      {
        for( j=0; j<m_numColMatrixBTextBox; j++)  
        {    
          db_MatrixB[i,j] = Convert.ToDouble(arrTextBoxMatrixB[i,j].Text) ;
        }
      }
    }

    /* ************************************ */
    public void GetMatrixC() 
    {
      // calculate matrix multiplication
      MWNumericArray mw_A = new MWNumericArray(db_MatrixA) ;
      MWNumericArray mw_B = new MWNumericArray(db_MatrixB) ;
      MWNumericArray mw_C = null ;
  
      /* call an implemental function */
      MatrixMultiplication objMatlab = new MatrixMultiplication() ;
      mw_C = (MWNumericArray) objMatlab.mymtimes(mw_A, mw_B) ;      

      /* convert back to C# double  */
      db_MatrixC = (double[,]) mw_C.ToArray(MWArrayComponent.Real) ;

      // display to GUI
      int i, j ;      
      for( i=0; i<m_numRowMatriCTextBox; i++) 
      {
        for( j=0; j<m_numColMatriCTextBox; j++)  
        {  
          arrTextBoxMatrixC[i,j].Text = db_MatrixC[i,j].ToString() ;
        }
      }

      mw_A.Dispose() ;
      mw_B.Dispose() ;
      mw_C.Dispose() ;
    }

    /* ************************************ */
    private void tbMatrixA_col_TextChanged(object sender, System.EventArgs e)
    {
      tbMatrixB_row.Text = tbMatrixA_col.Text ;
    }

/* ************************************ */
/* ************************************ */
/* ************************************ */
  }
}
