/*
* MATLAB Compiler: 4.11 (R2009b)
* Date: Sun Nov 15 15:57:23 2009
* Arguments: "-B" "macro_default" "-C" "-W"
* "dotnet:LinearSystemNameSpace,LinearSystem,2.0,encryption_keyfile_path,local"
* "mydiag.m" "myextractmatrix.m" "myfull.m" "mylu.m" "mymldivide.m" "mymrdivide.m"
* "mysparse.m" "myspdiags.m" "mytranspose.m" 
*/
using System;
using System.Reflection;
using MathWorks.MATLAB.NET.Arrays;
using MathWorks.MATLAB.NET.Utility;
using MathWorks.MATLAB.NET.ComponentData;

#if SHARED
[assembly: System.Reflection.AssemblyKeyFile(@"encryption_keyfile_path")]
#endif

namespace LinearSystemNameSpace
{
  /// <summary>
  /// The LinearSystem class provides a CLS compliant, MWArray interface to the
  /// M-functions contained in the files:
  /// <newpara></newpara>
  /// mydiag.m
  /// <newpara></newpara>
  /// myextractmatrix.m
  /// <newpara></newpara>
  /// myfull.m
  /// <newpara></newpara>
  /// mylu.m
  /// <newpara></newpara>
  /// mymldivide.m
  /// <newpara></newpara>
  /// mymrdivide.m
  /// <newpara></newpara>
  /// mysparse.m
  /// <newpara></newpara>
  /// myspdiags.m
  /// <newpara></newpara>
  /// mytranspose.m
  /// <newpara></newpara>
  /// deployprint.m
  /// <newpara></newpara>
  /// printdlg.m
  /// </summary>
  /// <remarks>
  /// @Version 2.0
  /// </remarks>
  public class LinearSystem : IDisposable
  {
    #region Constructors

    /// <summary internal= "true">
    /// The static constructor instantiates and initializes the MATLAB Component Runtime
    /// instance.
    /// </summary>
    static LinearSystem()
    {
      if (MWMCR.MCRAppInitialized)
      {
        Assembly assembly= Assembly.GetExecutingAssembly();

        string ctfFilePath= assembly.Location;

        int lastDelimiter= ctfFilePath.LastIndexOf(@"\");

        ctfFilePath= ctfFilePath.Remove(lastDelimiter, (ctfFilePath.Length - lastDelimiter));

        mcr= new MWMCR(MCRComponentState.MCC_LinearSystemNameSpace_name_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_root_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_public_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_session_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_matlabpath_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_classpath_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_libpath_data,
                       MCRComponentState.MCC_LinearSystemNameSpace_mcr_application_options,
                       MCRComponentState.MCC_LinearSystemNameSpace_mcr_runtime_options,
                       MCRComponentState.MCC_LinearSystemNameSpace_mcr_pref_dir,
                       MCRComponentState.MCC_LinearSystemNameSpace_set_warning_state,
                       ctfFilePath, true);
      }
      else
      {
        throw new ApplicationException("MWArray assembly could not be initialized");
      }
    }


    /// <summary>
    /// Constructs a new instance of the LinearSystem class.
    /// </summary>
    public LinearSystem()
    {
    }


    #endregion Constructors

    #region Finalize

    /// <summary internal= "true">
    /// Class destructor called by the CLR garbage collector.
    /// </summary>
    ~LinearSystem()
    {
      Dispose(false);
    }


    /// <summary>
    /// Frees the native resources associated with this object
    /// </summary>
    public void Dispose()
    {
      Dispose(true);

      GC.SuppressFinalize(this);
    }


    /// <summary internal= "true">
    /// Internal dispose function
    /// </summary>
    protected virtual void Dispose(bool disposing)
    {
      if (!disposed)
      {
        disposed= true;

        if (disposing)
        {
          // Free managed resources;
        }

        // Free native resources
      }
    }


    #endregion Finalize

    #region Methods

    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the mydiag M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mydiag()
    {
      return mcr.EvaluateFunction("mydiag", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the mydiag M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="v">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mydiag(MWArray v)
    {
      return mcr.EvaluateFunction("mydiag", v);
    }


    /// <summary>
    /// Provides a single output, 2-input MWArrayinterface to the mydiag M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="v">Input argument #1</param>
    /// <param name="k">Input argument #2</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mydiag(MWArray v, MWArray k)
    {
      return mcr.EvaluateFunction("mydiag", v, k);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the mydiag M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mydiag(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "mydiag", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the mydiag M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="v">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mydiag(int numArgsOut, MWArray v)
    {
      return mcr.EvaluateFunction(numArgsOut, "mydiag", v);
    }


    /// <summary>
    /// Provides the standard 2-input MWArray interface to the mydiag M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="v">Input argument #1</param>
    /// <param name="k">Input argument #2</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mydiag(int numArgsOut, MWArray v, MWArray k)
    {
      return mcr.EvaluateFunction(numArgsOut, "mydiag", v, k);
    }


    /// <summary>
    /// Provides an interface for the mydiag function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void mydiag(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("mydiag", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myextractmatrix()
    {
      return mcr.EvaluateFunction("myextractmatrix", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="A">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myextractmatrix(MWArray A)
    {
      return mcr.EvaluateFunction("myextractmatrix", A);
    }


    /// <summary>
    /// Provides a single output, 2-input MWArrayinterface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myextractmatrix(MWArray A, MWArray rowa)
    {
      return mcr.EvaluateFunction("myextractmatrix", A, rowa);
    }


    /// <summary>
    /// Provides a single output, 3-input MWArrayinterface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <param name="rowb">Input argument #3</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myextractmatrix(MWArray A, MWArray rowa, MWArray rowb)
    {
      return mcr.EvaluateFunction("myextractmatrix", A, rowa, rowb);
    }


    /// <summary>
    /// Provides a single output, 4-input MWArrayinterface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <param name="rowb">Input argument #3</param>
    /// <param name="cola">Input argument #4</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myextractmatrix(MWArray A, MWArray rowa, MWArray rowb, MWArray cola)
    {
      return mcr.EvaluateFunction("myextractmatrix", A, rowa, rowb, cola);
    }


    /// <summary>
    /// Provides a single output, 5-input MWArrayinterface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <param name="rowb">Input argument #3</param>
    /// <param name="cola">Input argument #4</param>
    /// <param name="colb">Input argument #5</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myextractmatrix(MWArray A, MWArray rowa, MWArray rowb, MWArray cola, 
                             MWArray colb)
    {
      return mcr.EvaluateFunction("myextractmatrix", A, rowa, rowb, cola, colb);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myextractmatrix(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "myextractmatrix", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myextractmatrix(int numArgsOut, MWArray A)
    {
      return mcr.EvaluateFunction(numArgsOut, "myextractmatrix", A);
    }


    /// <summary>
    /// Provides the standard 2-input MWArray interface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myextractmatrix(int numArgsOut, MWArray A, MWArray rowa)
    {
      return mcr.EvaluateFunction(numArgsOut, "myextractmatrix", A, rowa);
    }


    /// <summary>
    /// Provides the standard 3-input MWArray interface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <param name="rowb">Input argument #3</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myextractmatrix(int numArgsOut, MWArray A, MWArray rowa, MWArray 
                               rowb)
    {
      return mcr.EvaluateFunction(numArgsOut, "myextractmatrix", A, rowa, rowb);
    }


    /// <summary>
    /// Provides the standard 4-input MWArray interface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <param name="rowb">Input argument #3</param>
    /// <param name="cola">Input argument #4</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myextractmatrix(int numArgsOut, MWArray A, MWArray rowa, MWArray 
                               rowb, MWArray cola)
    {
      return mcr.EvaluateFunction(numArgsOut, "myextractmatrix", A, rowa, rowb, cola);
    }


    /// <summary>
    /// Provides the standard 5-input MWArray interface to the myextractmatrix
    /// M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <param name="rowa">Input argument #2</param>
    /// <param name="rowb">Input argument #3</param>
    /// <param name="cola">Input argument #4</param>
    /// <param name="colb">Input argument #5</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myextractmatrix(int numArgsOut, MWArray A, MWArray rowa, MWArray 
                               rowb, MWArray cola, MWArray colb)
    {
      return mcr.EvaluateFunction(numArgsOut, "myextractmatrix", A, rowa, rowb, cola, colb);
    }


    /// <summary>
    /// Provides an interface for the myextractmatrix function in which the input and
    /// output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// M-Documentation:
    /// extract from row a to row b, and from col a to col b</remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void myextractmatrix(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("myextractmatrix", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the myfull M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myfull()
    {
      return mcr.EvaluateFunction("myfull", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the myfull M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="S">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myfull(MWArray S)
    {
      return mcr.EvaluateFunction("myfull", S);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the myfull M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myfull(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "myfull", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the myfull M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="S">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myfull(int numArgsOut, MWArray S)
    {
      return mcr.EvaluateFunction(numArgsOut, "myfull", S);
    }


    /// <summary>
    /// Provides an interface for the myfull function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void myfull(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("myfull", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the mylu M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mylu()
    {
      return mcr.EvaluateFunction("mylu", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the mylu M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="A">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mylu(MWArray A)
    {
      return mcr.EvaluateFunction("mylu", A);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the mylu M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mylu(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "mylu", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the mylu M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mylu(int numArgsOut, MWArray A)
    {
      return mcr.EvaluateFunction(numArgsOut, "mylu", A);
    }


    /// <summary>
    /// Provides an interface for the mylu function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void mylu(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("mylu", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the mymldivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mymldivide()
    {
      return mcr.EvaluateFunction("mymldivide", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the mymldivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <param name="A">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mymldivide(MWArray A)
    {
      return mcr.EvaluateFunction("mymldivide", A);
    }


    /// <summary>
    /// Provides a single output, 2-input MWArrayinterface to the mymldivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <param name="A">Input argument #1</param>
    /// <param name="b">Input argument #2</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mymldivide(MWArray A, MWArray b)
    {
      return mcr.EvaluateFunction("mymldivide", A, b);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the mymldivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mymldivide(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "mymldivide", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the mymldivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mymldivide(int numArgsOut, MWArray A)
    {
      return mcr.EvaluateFunction(numArgsOut, "mymldivide", A);
    }


    /// <summary>
    /// Provides the standard 2-input MWArray interface to the mymldivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <param name="b">Input argument #2</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mymldivide(int numArgsOut, MWArray A, MWArray b)
    {
      return mcr.EvaluateFunction(numArgsOut, "mymldivide", A, b);
    }


    /// <summary>
    /// Provides an interface for the mymldivide function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// M-Documentation:
    /// solve equation Ax = b 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void mymldivide(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("mymldivide", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the mymrdivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mymrdivide()
    {
      return mcr.EvaluateFunction("mymrdivide", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the mymrdivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <param name="A">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mymrdivide(MWArray A)
    {
      return mcr.EvaluateFunction("mymrdivide", A);
    }


    /// <summary>
    /// Provides a single output, 2-input MWArrayinterface to the mymrdivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <param name="A">Input argument #1</param>
    /// <param name="b">Input argument #2</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mymrdivide(MWArray A, MWArray b)
    {
      return mcr.EvaluateFunction("mymrdivide", A, b);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the mymrdivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mymrdivide(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "mymrdivide", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the mymrdivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mymrdivide(int numArgsOut, MWArray A)
    {
      return mcr.EvaluateFunction(numArgsOut, "mymrdivide", A);
    }


    /// <summary>
    /// Provides the standard 2-input MWArray interface to the mymrdivide M-function.
    /// </summary>
    /// <remarks>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <param name="b">Input argument #2</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mymrdivide(int numArgsOut, MWArray A, MWArray b)
    {
      return mcr.EvaluateFunction(numArgsOut, "mymrdivide", A, b);
    }


    /// <summary>
    /// Provides an interface for the mymrdivide function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// M-Documentation:
    /// solve equation xA = b ==> 
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void mymrdivide(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("mymrdivide", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the mysparse M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mysparse()
    {
      return mcr.EvaluateFunction("mysparse", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the mysparse M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="A">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mysparse(MWArray A)
    {
      return mcr.EvaluateFunction("mysparse", A);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the mysparse M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mysparse(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "mysparse", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the mysparse M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="A">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mysparse(int numArgsOut, MWArray A)
    {
      return mcr.EvaluateFunction(numArgsOut, "mysparse", A);
    }


    /// <summary>
    /// Provides an interface for the mysparse function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void mysparse(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("mysparse", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myspdiags()
    {
      return mcr.EvaluateFunction("myspdiags", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="B">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myspdiags(MWArray B)
    {
      return mcr.EvaluateFunction("myspdiags", B);
    }


    /// <summary>
    /// Provides a single output, 2-input MWArrayinterface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="B">Input argument #1</param>
    /// <param name="d">Input argument #2</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myspdiags(MWArray B, MWArray d)
    {
      return mcr.EvaluateFunction("myspdiags", B, d);
    }


    /// <summary>
    /// Provides a single output, 3-input MWArrayinterface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="B">Input argument #1</param>
    /// <param name="d">Input argument #2</param>
    /// <param name="m">Input argument #3</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myspdiags(MWArray B, MWArray d, MWArray m)
    {
      return mcr.EvaluateFunction("myspdiags", B, d, m);
    }


    /// <summary>
    /// Provides a single output, 4-input MWArrayinterface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="B">Input argument #1</param>
    /// <param name="d">Input argument #2</param>
    /// <param name="m">Input argument #3</param>
    /// <param name="n">Input argument #4</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray myspdiags(MWArray B, MWArray d, MWArray m, MWArray n)
    {
      return mcr.EvaluateFunction("myspdiags", B, d, m, n);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myspdiags(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "myspdiags", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="B">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myspdiags(int numArgsOut, MWArray B)
    {
      return mcr.EvaluateFunction(numArgsOut, "myspdiags", B);
    }


    /// <summary>
    /// Provides the standard 2-input MWArray interface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="B">Input argument #1</param>
    /// <param name="d">Input argument #2</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myspdiags(int numArgsOut, MWArray B, MWArray d)
    {
      return mcr.EvaluateFunction(numArgsOut, "myspdiags", B, d);
    }


    /// <summary>
    /// Provides the standard 3-input MWArray interface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="B">Input argument #1</param>
    /// <param name="d">Input argument #2</param>
    /// <param name="m">Input argument #3</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myspdiags(int numArgsOut, MWArray B, MWArray d, MWArray m)
    {
      return mcr.EvaluateFunction(numArgsOut, "myspdiags", B, d, m);
    }


    /// <summary>
    /// Provides the standard 4-input MWArray interface to the myspdiags M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="B">Input argument #1</param>
    /// <param name="d">Input argument #2</param>
    /// <param name="m">Input argument #3</param>
    /// <param name="n">Input argument #4</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] myspdiags(int numArgsOut, MWArray B, MWArray d, MWArray m, MWArray n)
    {
      return mcr.EvaluateFunction(numArgsOut, "myspdiags", B, d, m, n);
    }


    /// <summary>
    /// Provides an interface for the myspdiags function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void myspdiags(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("myspdiags", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// Provides a single output, 0-input MWArrayinterface to the mytranspose M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mytranspose()
    {
      return mcr.EvaluateFunction("mytranspose", new MWArray[]{});
    }


    /// <summary>
    /// Provides a single output, 1-input MWArrayinterface to the mytranspose M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="x">Input argument #1</param>
    /// <returns>An MWArray containing the first output argument.</returns>
    ///
    public MWArray mytranspose(MWArray x)
    {
      return mcr.EvaluateFunction("mytranspose", x);
    }


    /// <summary>
    /// Provides the standard 0-input MWArray interface to the mytranspose M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mytranspose(int numArgsOut)
    {
      return mcr.EvaluateFunction(numArgsOut, "mytranspose", new MWArray[]{});
    }


    /// <summary>
    /// Provides the standard 1-input MWArray interface to the mytranspose M-function.
    /// </summary>
    /// <remarks>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return.</param>
    /// <param name="x">Input argument #1</param>
    /// <returns>An Array of length "numArgsOut" containing the output
    /// arguments.</returns>
    ///
    public MWArray[] mytranspose(int numArgsOut, MWArray x)
    {
      return mcr.EvaluateFunction(numArgsOut, "mytranspose", x);
    }


    /// <summary>
    /// Provides an interface for the mytranspose function in which the input and output
    /// arguments are specified as an array of MWArrays.
    /// </summary>
    /// <remarks>
    /// This method will allocate and return by reference the output argument
    /// array.<newpara></newpara>
    /// </remarks>
    /// <param name="numArgsOut">The number of output arguments to return</param>
    /// <param name= "argsOut">Array of MWArray output arguments</param>
    /// <param name= "argsIn">Array of MWArray input arguments</param>
    ///
    public void mytranspose(int numArgsOut, ref MWArray[] argsOut, MWArray[] argsIn)
    {
      mcr.EvaluateFunction("mytranspose", numArgsOut, ref argsOut, argsIn);
    }


    /// <summary>
    /// This method will cause a MATLAB figure window to behave as a modal dialog box.
    /// The method will not return until all the figure windows associated with this
    /// component have been closed.
    /// </summary>
    /// <remarks>
    /// An application should only call this method when required to keep the
    /// MATLAB figure window from disappearing.  Other techniques, such as calling
    /// Console.ReadLine() from the application should be considered where
    /// possible.</remarks>
    ///
    public void WaitForFiguresToDie()
    {
      mcr.WaitForFiguresToDie();
    }



    #endregion Methods

    #region Class Members

    private static MWMCR mcr= null;

    private bool disposed= false;

    #endregion Class Members
  }
}
